﻿--[[----------------------------------------------------------------------
      Notifier Module - Part of VanasKoS
Notifies the user via Tooltip, Chat and Upper Area of a KoS/other List Target
------------------------------------------------------------------------]]

local L = AceLibrary("AceLocale-2.2"):new("VanasKoSNotifier");
VanasKoSNotifier = VanasKoS:NewModule("Notifier");

L:RegisterTranslations("enUS", function() return {
	["KoS: %s"] = "KoS: %s",
	["KoS (Guild): %s"] = "KoS (Guild): %s",
	["Nicelist: %s"] = "Nicelist: %s",
	["Hatelist: %s"] = "Hatelist: %s",
	["%sKoS: %s"] = "|cffff00ff%s's|r KoS: %s",
	["%sKoS (Guild): %s"] = "|cffff00ff%s's|r KoS (Guild): %s",
	["%sNicelist: %s"] = "|cffff00ff%s's|r Nicelist: %s",
	["%sHatelist: %s"] = "|cffff00ff%s's|r Hatelist: %s",
	
	["Notifications"] = true,
	["Notification in the Upper Area"] = true,
	["Notification in the Chatframe"] = true,
	["Notification through Target Portrait"] = true,
	["Notify only on my KoS-Targets"] = true,
	["Sound on KoS detection"] = true,
	["Notification Interval (seconds)"] = true,
	["Enabled"]  = true,
	["None"] = true,
	["wins: %d - losses: %d"] = "wins: |cff00ff00%d|r losses: |cffff0000%d|r",
	["Show PvP-Stats in Tooltip"] = true,
} end);

L:RegisterTranslations("deDE", function() return {
	["KoS: %s"] = "KoS: %s",
	["KoS (Guild): %s"] = "KoS (Gilde): %s",
	["Nicelist: %s"] = "Nette-Leute Liste: %s",
	["Hatelist: %s"] = "Hassliste: %s",
	["%sKoS: %s"] = "|cffff00ff%ss|r KoS: %s",
	["%sKoS (Guild): %s"] = "|cffff00ff%ss|r KoS (Gilde): %s",
	["%sNicelist: %s"] = "|cffff00ff%ss|r Nette-Leute Liste: %s",
	["%sHatelist: %s"] = "|cffff00ff%ss|r Hassliste: %s",

	["Notifications"] = "Benachrichtigungen",
	["Notification in the Upper Area"] = "Benachrichtigung im oberen Bereich",
	["Notification in the Chatframe"] = "Benachrichtigung im Chat-Fenster",
	["Notification through Target Portrait"] = "Benachrichtigung durch aendern des Ziel-Fensters",
	["Notify only on my KoS-Targets"] = "Nur meine KoS-Ziele benachrichtigen",
	["Sound on KoS detection"] = "Audio Benachrichtigung bei KoS",
	["Notification Interval (seconds)"] = "Benachrichtigungs Interval (Sekunden)",
	["Enabled"] = "Aktiviert",
	["None"] = "Keiner",
	["wins: %d - losses: %d"] = "gewonnen: |cff00ff00%d|r verloren: |cffff0000%d|r",
	["Show PvP-Stats in Tooltip"] = "Anzeigen von PvP-Statistiken im Tooltip",
} end);

L:RegisterTranslations("frFR", function() return {
	["KoS: %s"] = "KoS: %s",
	["KoS (Guild): %s"] = "KoS (Guilde): %s",
	["Nicelist: %s"] = "Liste blanche: %s",
	["Hatelist: %s"] = "Liste noire: %s",
	["%sKoS: %s"] = "KoS à |cffff00ff%s|r: %s",
	["%sKoS (Guild): %s"] = "KoS (Guilde) à |cffff00ff%s|r: %s",
	["%sNicelist: %s"] = "Liste blanche à |cffff00ff%s|r: %s",
	["%sHatelist: %s"] = "Liste noire à |cffff00ff%s|r: %s",

	["Notifications"] = "Notifications",
	["Notification in the Upper Area"] = "Notification en message principal central",
	["Notification in the Chatframe"] = "Notification dans la fen\195\170tre de discussion",
	["Notification through Target Portrait"] = "Notification avec portrait (dragon élite)",
	["Notify only on my KoS-Targets"] = "Notification de mes propres cibles seulement",
	["Sound on KoS detection"] = "Son de d\195\169tection KoS",
	["Notification Interval (seconds)"] = "Intervalle entre notifications (secondes)",
	["Enabled"] = "Actif",
	["None"] = "Aucun",
	["wins: %d - losses: %d"] = "victoires: |cff00ff00%d|r d\195\169faites: |cffff0000%d|r",
	["Show PvP-Stats in Tooltip"] = "Afficher PvP-Stats dans le Tooltip",
} end);

L:RegisterTranslations("koKR", function() return {
	["KoS: %s"] = "KoS: %s",
	["KoS (Guild): %s"] = "KoS (길드): %s",
	["Nicelist: %s"] = "우호적목록: %s",
	["Hatelist: %s"] = "적대적목록: %s",
-- thanks for all the translations to korean - please translate these to work in korean, they mean that the listentry is on someone else's list
-- first %s is the guy witht he list, the second %s is the reason
--	["%sKoS: %s"] = "|cffff00ff%s's|rKoS: %s",
--	["%sKoS (Guild): %s"] = "|cffff00ff%s's|rKoS (Guild): %s",
--	["%sNicelist: %s"] = "|cffff00ff%s's|rNicelist: %s",
--	["%sHatelist: %s"] = "|cffff00ff%s's|rHatelist: %s",

	["Notifications"] = "알림",
	["Notification in the Upper Area"] = "상단 영역에 알림",
	["Notification in the Chatframe"] = "대화창에 알림",
	["Notification through Target Portrait"] = "대상 사진을 통해 알림",
	["Notify only on my KoS-Targets"] = "나의 KoS-대상일 경우만 알림",
	["Sound on KoS detection"] = "KoS 발견 효과음",
	["Notification Interval (seconds)"] = "알림 간격(초)",
	["Enabled"]  = "사용중",
	["None"] = "없음",
	["wins: %d - losses: %d"] = "승: |cff00ff00%d|r 패: |cffff0000%d|r",
--	["Show PvP-Stats in Tooltip"] = "Afficher PvP-Stats dans le Tooltip",
} end);

local notifyAllowed = true;

function VanasKoSNotifier:OnInitialize()
	VanasKoSGUI:AddConfigOption("Notifier", {
		type = 'group',
		name = L["Notifications"],
		desc = L["Notifications"],
		args = {
			enabled = {
				type = 'toggle',
				name = L["Enabled"],
				desc = L["Enabled"],
				order = 1,
				set = function() VanasKoS:TogOpt("notifyEnabled"); VanasKoS:ToggleModuleActive("Notifier", VanasKoS:GetOpt("notifyEnabled")); end,
				get = function() return VanasKoS:GetOpt("notifyEnabled"); end,
			},
			upperarea = {
				type = 'toggle',
				name = L["Notification in the Upper Area"],
				desc = L["Notification in the Upper Area"],
				order = 2,
				set = function() VanasKoS:TogOpt("notifyVisual"); end,
				get = function() return VanasKoS:GetOpt("notifyVisual"); end,
			},
			chatframe = {
				type = 'toggle',
				name = L["Notification in the Chatframe"],
				desc = L["Notification in the Chatframe"],
				order = 3,
				set = function() VanasKoS:TogOpt("notifyChatframe"); end,
				get = function() return VanasKoS:GetOpt("notifyChatframe"); end,
			},
			targetframe = {
				type = 'toggle',
				name = L["Notification through Target Portrait"],
				desc = L["Notification through Target Portrait"],
				order = 4,
				set = function() VanasKoS:TogOpt("notifyTargetFrame"); end,
				get = function() return VanasKoS:GetOpt("notifyTargetFrame"); end,
			},
			onlymytargets = {
				type = 'toggle',
				name = L["Notify only on my KoS-Targets"],
				desc = L["Notify only on my KoS-Targets"],
				order = 5,
				set = function() VanasKoS:TogOpt("notifyOnlyMyTargets"); end,
				get = function() return VanasKoS:GetOpt("notifyOnlyMyTargets"); end,
			},
			showpvpstats = {
				type = 'toggle',
				name = L["Show PvP-Stats in Tooltip"],
				desc = L["Show PvP-Stats in Tooltip"],
				order = 6,
				set = function() VanasKoS:TogOpt("notifyShowPvPStats"); end,
				get = function() return VanasKoS:GetOpt("notifyShowPvPStats"); end,
			},
			notificationInterval = {
				type = 'range',
				name = L["Notification Interval (seconds)"],
				desc = L["Notification Interval (seconds)"],
				min = 0,
				max = 600,
				step = 1,
				order = 7,
				set = function(value) VanasKoS:SetOpt("NotifyTimerInterval", value); end,
				get = function() return VanasKoS:GetOpt("NotifyTimerInterval"); end,
			},
			sound = {
				type = 'group',
				name = L["Sound on KoS detection"],
				desc = L["Sound on KoS detection"],
				order = 8,
				args = {
					none = {
						type = 'toggle',
						name = L["None"],
						desc = L["None"],
						order = 1,
						set = function(value) VanasKoS:SetOpt("playSound", false); end,
						get = function() return not VanasKoS:GetOpt("playSound"); end,
						isRadio = true,
					},
					sound1 = {
						type = 'toggle',
						name = "Bonus Bar",
						desc = "Bonus Bar",
						set = function(value) VanasKoS:SetOpt("playSound", true); VanasKoS:SetOpt("playSoundName", "igBonusBarOpen"); VanasKoSNotifier:PlaySound(); end,
						get = function() if(VanasKoS:GetOpt("playSound") and VanasKoS:GetOpt("playSoundName") == "igBonusBarOpen") then return true; else return false; end end,
						isRadio = true
					},
					sound2 = {
						type = 'toggle',
						name = "Auction House",
						desc = "Auction House",
						set = function(value) VanasKoS:SetOpt("playSound", true); VanasKoS:SetOpt("playSoundName", "AuctionWindowOpen"); VanasKoSNotifier:PlaySound(); end,
						get = function() if(VanasKoS:GetOpt("playSound") and VanasKoS:GetOpt("playSoundName") == "AuctionWindowOpen") then return true; else return false; end end,
						isRadio = true
					},
					sound3 = {
						type = 'toggle',
						name = "String Fading",
						desc = "String Fading",
						set = function(value) VanasKoS:SetOpt("playSound", true); VanasKoS:SetOpt("playSoundName", "Interface\\AddOns\\VanasKoS\\Artwork\\StringFading.mp3"); VanasKoSNotifier:PlaySound(); end,
						get = function() if(VanasKoS:GetOpt("playSound") and VanasKoS:GetOpt("playSoundName") == "Interface\\AddOns\\VanasKoS\\Artwork\\StringFading.mp3") then return true; else return false; end end,
						isRadio = true,
					}
				}
			},
		}
	});
end

function VanasKoSNotifier:OnEnable()
	if(not VanasKoS:GetOpt("notifyEnabled")) then
		return;
	end
	self:RegisterEvent("VanasKoS_Player_Detected", "Player_Detected");
	self:RegisterEvent("VanasKoS_Player_Target_Changed", "Player_Target_Changed");
	self:RegisterEvent("VanasKoS_Mob_Target_Changed", "Player_Target_Changed");
	self:RegisterEvent("VanasKoS_Player_MouseOver", "Player_MouseOver");
end

function VanasKoSNotifier:OnDisable()
	self:UnregisterAllEvents();
end

function VanasKoSNotifier:Tooltip_AddMessage(msg)
	GameTooltip:AddLine(msg);

	-- resize
	local newWidth = 0;
	local numlines = GameTooltip:NumLines();
	GameTooltip:SetHeight((numlines*15) + 15);

	for i = 1, numlines do
        local checkText = getglobal("GameTooltipTextLeft"..i);
        if (checkText and ((checkText:GetWidth() + 24) > newWidth)) then
                newWidth = (checkText:GetWidth() + 24);
        end
	end
	GameTooltip:SetWidth(newWidth);
end

local listsToCheck = {
		['PLAYERKOS'] = { L["KoS: %s"], L["%sKoS: %s"] },
		['GUILDKOS'] = { L["KoS (Guild): %s"], L["%sKoS (Guild): %s"] },
		['NICELIST'] = { L["Nicelist: %s"], L["%sNicelist: %s"] },
		['HATELIST'] = { L["Hatelist: %s"], L["%sHatelist: %s"] },
	};

function VanasKoSNotifier:Player_MouseOver(name, guild, faction)
	for k,v in pairs(listsToCheck) do
		local reason, creator;
		if(k ~= "GUILDKOS") then
			reason, creator = VanasKoS:IsOnList(k, name);
		else
			reason, creator = VanasKoS:IsOnList(k, guild);
		end
		if(reason ~= nil) then
			if(creator == nil) then
				self:Tooltip_AddMessage(format(v[1], reason));
			else
				self:Tooltip_AddMessage(format(v[2], creator, reason));
			end
		end
	end
	if(VanasKoS:GetOpt("notifyShowPvPStats")) then
		local wins, losses = VanasKoS:IsOnList("PVPSTATS", name);
		if(wins == nil) then
			wins = 0;
		end
		if(losses == nil) then
			losses = 0;
		end
		if(wins ~= 0 or losses ~= 0) then
			self:Tooltip_AddMessage(format(L["wins: %d - losses: %d"], wins, losses));
		end
	end
end

function VanasKoSNotifier:Player_Target_Changed(name, guild, faction)
	if(VanasKoS:GetOpt("notifyTargetFrame")) then
		if(UnitIsPlayer("target")) then
			if(VanasKoS:IsKoSPlayer(name)) then
				TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Elite");
				TargetFrameTexture:SetVertexColor(1.0, 1.0, 1.0, TargetFrameTexture:GetAlpha());
			elseif(VanasKoS:IsKoSGuild(guild)) then
				TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Rare");
				TargetFrameTexture:SetVertexColor(1.0, 1.0, 1.0, TargetFrameTexture:GetAlpha());
			elseif(VanasKoS:IsOnList("NICELIST", name)) then
				TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Rare");
				TargetFrameTexture:SetVertexColor(0.0, 1.0, 0.0, TargetFrameTexture:GetAlpha());
			elseif(VanasKoS:IsOnList("HATELIST", name)) then
				TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Rare");
				TargetFrameTexture:SetVertexColor(1.0, 0.0, 0.0, TargetFrameTexture:GetAlpha());
			else
				TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame");
				TargetFrameTexture:SetVertexColor(1.0, 1.0, 1.0, TargetFrameTexture:GetAlpha());
			end
		else
			--TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame");
			TargetFrameTexture:SetVertexColor(1.0, 1.0, 1.0, TargetFrameTexture:GetAlpha());
		end
	end
end

function VanasKoSNotifier:Player_Detected(name, guild, faction)
	if (notifyAllowed ~= true) then
		return nil;
	end
	
	notifyAllowed = false;
	
	-- Reallow Notifies in NotifyTimeInterval Time
	self:ScheduleEvent(function() notifyAllowed = true end, VanasKoS:GetOpt("NotifyTimerInterval"));

	local msg = "";

	local reason, creator = VanasKoS:IsOnList("PLAYERKOS", name);
	if(reason ~= nil) then
		if(creator ~= nil and creator ~= "") then
			msg = format(L["%sKoS: %s"], creator, name .. " (" .. reason .. ")");
		else
			msg = format(L["KoS: %s"], name .. " (" .. reason .. ")");
		end
		if(guild) then
			msg = msg .. " <" .. guild .. ">";
			if(VanasKoS:IsKoSGuild(guild)) then
				msg = msg .. " (" .. VanasKoS:IsKoSGuild(guild) .. ")";
			end
		end
	elseif(VanasKoS:IsKoSGuild(guild)) then
		msg = format(L["KoS (Guild): %s"], name .. " <" .. guild .. "> (" .. VanasKoS:IsKoSGuild(guild) .. ")");
	else
		return;
	end

	if(VanasKoS:GetOpt("notifyOnlyMyTargets")) then
		local reason, creator = VanasKoS:IsOnList("PLAYERKOS", name);
		if(creator ~= nil) then
			return;
		end
		local reason, creator = VanasKoS:IsOnList("GUILDKOS", guild);
		if(creator ~= nil) then
			return;
		end
	end
	
	if(VanasKoS:GetOpt("notifyVisual")) then
		UIErrorsFrame:AddMessage(msg, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
	end
	if(VanasKoS:GetOpt("notifyChatframe")) then
		VanasKoS:Print(msg);
	end
	if(VanasKoS:GetOpt("playSound")) then
		self:PlaySound();
	end
end

function VanasKoSNotifier:PlaySound()
	local soundname = VanasKoS:GetOpt("playSoundName");
	if(soundname == nil or soundname == "") then
		soundname = "igBonusBarOpen";
	end

	if(string.find(soundname, "\\")) then
		PlaySoundFile(soundname);
	else
		PlaySound(soundname);
	end
end
