﻿--[[----------------------------------------------------------------------
      WarnFrame Module - Part of VanasKoS
Creates the WarnFrame to alert of nearby KoS, Hostile and Friendly
------------------------------------------------------------------------]]
local nearbyKos = { };
local nearbyEnemys = { };
local nearbyFriendly = { };

local L = AceLibrary("AceLocale-2.2"):new("VanasKoSWarnFrame");
VanasKoSWarnFrame = VanasKoS:NewModule("WarnFrame");

local NOTIFYTIMERINTERVAL = 60;


L:RegisterTranslations("enUS", function() return {
	["Content"] = true,
	["What to show in it"] = true,
	["Design"] = true,
	["How the content is shown"] = true,
	
	["Show KoS Targets"] = true,
	["Show Hostile Targets"] = true,
	["Show Friendly Targets"] = true,
	
	["Default Background Color"] = true,
	["Sets the default Background Color and Opacity"] = true,
	
	["More Hostiles than Allied Background Color"] = true,
	["Sets the more Hostiles than Allied Background Color and Opacity"] = true,
	
	["More Allied than Hostiles Background Color"] = true,
	["Sets the more Allied than Hostiles Background Color and Opacity"] = true,

	["Reset Background Colors"] = true,
	["Resets all Background Colors to default Settings"] = true,
	
	["Configuration"] = true,
	["KoS/Enemy/Friendly Warning Window"] = true,
	["Hide if inactive"] = true,
	["Enabled"] = true,
	["Locked"] = true,
	
	-- the text that appears in the combat log when the name of the target isn't known
	["_Unknown Entity_"] = UNKNOWN,
} end );
	
L:RegisterTranslations("deDE", function() return {
	["Content"] = "Inhalt",
	["What to show in it"] = "Was angezeigt wird",
	["Design"] = "Aussehen",
	["How the content is shown"] = "Aussehen der anzeigten Daten",

	["Show KoS Targets"] = "KoS-Ziele anzeigen",
	["Show Hostile Targets"] = "Feindliche Ziele anzeigen",
	["Show Friendly Targets"] = "Freundliche Ziele anzeigen",
	
	["Default Background Color"] = "Standard Hintergrundfarbe",
	["Sets the default Background Color and Opacity"] = "Setzt die standardmaessige Hintergrundfarbe und Transparenz",
	
	["More Hostiles than Allied Background Color"] = "Mehr Feinde als Verbuendete Hintergrundfarbe",
	["Sets the more Hostiles than Allied Background Color and Opacity"] = "Setzt die Hintergrundfarbe und Transparenz wenn mehr Feinde als Verbuendete da sind",
	
	["More Allied than Hostiles Background Color"] = "Mehr Verbuendete als Feinde Hintergrundfarbe",
	["Sets the more Allied than Hostiles Background Color and Opacity"] = "Setzt die Hintergrundfarbe und Transparenz wenn mehr Verbuendete als Feinde da sind",
	
	["Reset Background Colors"] = "Hintergrundfarben zuruecksetzen",
	["Resets all Background Colors to default Settings"] = "Alle Hintergrundfarben auf ihre Standardwerte zuruecksetzen",

	["Configuration"] = "Konfiguration",
	["KoS/Enemy/Friendly Warning Window"] = "KoS/Feind/Freund Warn-Fenster",
	["Hide if inactive"] = "Verstecken wenn inaktiv",
	["Enabled"] = "Aktiviert",
	["Locked"] = "Sperren",
	["_Unknown Entity_"] = UNKNOWN,
} end );

L:RegisterTranslations("frFR", function() return {
	["Content"] = "Contenu",
	["What to show in it"] = "Ce que vous voulez afficher",
	["Design"] = "Apparence",
	["How the content is shown"] = "Comment l'apparence est affich\195\169",

	["Show KoS Targets"] = "Afficher cibles KoS",
	["Show Hostile Targets"] = "Afficher cibles hostiles",
	["Show Friendly Targets"] = "Afficher cibles amis",

	["Default Background Color"] = "Couleur de fond",
	["Sets the default Background Color and Opacity"] = "Choisir la couleur et l'opacit\195\169",

	["More Hostiles than Allied Background Color"] = "Couleur de fond pour cible hostile",
	["Sets the more Hostiles than Allied Background Color and Opacity"] = "Choisir la couleur de fond pour cible hostile",

	["More Allied than Hostiles Background Color"] = "Couleur de fond pour cible amical",
	["Sets the more Allied than Hostiles Background Color and Opacity"] = "Choisir la couleur de fond pour cible amical",

	["Reset Background Colors"] = "Remettre par d\195\169faut",
	["Resets all Background Colors to default Settings"] = "Remet par d\195\169faut la couleur de fond et l'opacit\195\169",

	["Configuration"] = "Configuration",
	["KoS/Enemy/Friendly Warning Window"] = "Fen\195\170tre d'avertissement KoS/Ennemi/Amis",
	["Hide if inactive"] = "Cacher si inactif",
	["Enabled"] = "Actif",
	["Locked"] = "Verrouill\195\169",
	
	-- the text that appears in the combat log when the name of the target isn't known
	["_Unknown Entity_"] = UNKNOWN,
} end );

L:RegisterTranslations("koKR", function() return {
	["Content"] = "내용",
	["What to show in it"] = "표시 내용",
	["Design"] = "디자인",
	["How the content is shown"] = "표시 방법",
	
	["Show KoS Targets"] = "KoS 대상 표시",
	["Show Hostile Targets"] = "적대적 대상 표시",
	["Show Friendly Targets"] = "우호적 대상 표시",
	
	["Default Background Color"] = "기본 배경 색상",
	["Sets the default Background Color and Opacity"] = "기본 배경의 색상과 투명도를 설정합니다.",
	
	["More Hostiles than Allied Background Color"] = "적대적 배경 색상",
	["Sets the more Hostiles than Allied Background Color and Opacity"] = "적대적 배경 색상과 투명도를 설정합니다.",
	
	["More Allied than Hostiles Background Color"] = "우호적 배경 색상",
	["Sets the more Allied than Hostiles Background Color and Opacity"] = "우호적 배경 색상과 투명도를 설정합니다.",

	["Reset Background Colors"] = "배경 색상 초기화",
	["Resets all Background Colors to default Settings"] = "모든 배경 색상을 기본 설정으로 초기화합니다.",
	
	["Configuration"] = "환경설정",
	["KoS/Enemy/Friendly Warning Window"] = "KoS/적대적/우호적 알림창",
	["Hide if inactive"] = "사용하지 않으면 숨김",
	["Enabled"] = "사용중",
	["Locked"] = "고정됨",
	

	-- the text that appears in the combat log when the name of the target isn't known
	["_Unknown Entity_"] = UNKNOWN,
} end );

local dewdrop = AceLibrary("Dewdrop-2.0");

function VanasKoSWarnFrame:OnInitialize()
	local name = "VanasKoS_WarnFrame";
	self.frame = CreateFrame("Button", name, UIParent);
	local frame = self.frame;
	
	frame:SetWidth(130);
	frame:SetHeight(81);
	frame:SetPoint("CENTER");
	frame:SetToplevel(true);
	frame:SetMovable(true);
	frame:SetFrameStrata("LOW");
	frame:EnableMouse(true);
	frame:SetBackdrop( {
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16,
			insets = { left = 5, right = 4, top = 5, bottom = 5 }
		});
	
	local r, g, b, a = self:GetColor("WarnFrameDefaultBGColor");
	frame:SetBackdropColor(r, g, b, a);
	
	frame:RegisterForDrag("LeftButton");
	
	frame:RegisterForClicks("RightButtonUp", "LeftButtonUp");
	frame:SetScript("OnClick", function()
									if(arg1 == "RightButton") then
										dewdrop:Open(VanasKoSWarnFrame.frame);
									end
								end);
	frame:SetScript("OnDragStart",
								function()
									if(VanasKoS:GetOpt("WarnFrameLocked")) then
										return;
									end
									frame:StartMoving();
								end);
	frame:SetScript("OnDragStop",
								function()
									frame:StopMovingOrSizing();
								end);
	for i=0,4,1 do
		local fontstring = frame:CreateFontString(name .. "Text" .. i, "BACKGROUND", "TextStatusBar");
		if(i == 0) then
			fontstring:SetPoint("TOP", frame, 0, -6);
		else
			fontstring:SetPoint("TOP", "VanasKoS_WarnFrameText" .. (i - 1), "BOTTOM", 0, 0);
		end
		fontstring:SetFontObject("GameFontNormal");
	end
	
	local configOptions = {
		type = 'group',
		name = L["Configuration"],
		desc = L["Configuration"],
		args = {
			title = {
				type = 'header',
				name = L["Configuration"],
				order = 1,
			},
			content = {
				type = 'group',
				name = L["Content"],
				desc = L["What to show in it"],
				order = 2,
				args = {
					showKoS = {
						type = 'toggle',
						name = L["Show KoS Targets"],
						desc = L["Show KoS Targets"],
						order = 1,
						get = function() return VanasKoS:GetOpt("WarnFrameShowKoS"); end,
						set = function() VanasKoS:TogOpt("WarnFrameShowKoS"); VanasKoSWarnFrame:Update(); end
					},
					showHostile = {
						type = 'toggle',
						name = L["Show Hostile Targets"],
						desc = L["Show Hostile Targets"],
						order = 2,
						get = function() return VanasKoS:GetOpt("WarnFrameShowHostile"); end,
						set = function() VanasKoS:TogOpt("WarnFrameShowHostile"); VanasKoSWarnFrame:Update(); end
					},
					showFriendly = {
						type = 'toggle',
						name = L["Show Friendly Targets"],
						desc = L["Show Friendly Targets"],
						order = 3,
						get = function() return VanasKoS:GetOpt("WarnFrameShowFriendly"); end,
						set = function() VanasKoS:TogOpt("WarnFrameShowFriendly"); VanasKoSWarnFrame:Update(); end
					}
				}
			},
			design = {
				type = 'group',
				name = L["Design"],
				desc = L["How the content is shown"],
				order = 3,
				args = {
					defaultBackdropBackgroundColor = {
						type = 'color',
						name = L["Default Background Color"],
						desc = L["Sets the default Background Color and Opacity"],
						order = 1,
						get = function() return VanasKoSWarnFrame:GetColor("WarnFrameDefaultBGColor") end,
						set = function(r, g, b, a) VanasKoSWarnFrame:SetColor("WarnFrameDefaultBGColor", r, g, b, a); end,
						hasAlpha = true,
					},
					moreHostilesBackdropBackgroundColor = {
						type = 'color',
						name = L["More Hostiles than Allied Background Color"],
						desc = L["Sets the more Hostiles than Allied Background Color and Opacity"],
						order = 2,
						get = function() return VanasKoSWarnFrame:GetColor("WarnFrameMoreHostileBGColor"); end,
						set = function(r, g, b, a) VanasKoSWarnFrame:SetColor("WarnFrameMoreHostileBGColor", r, g, b, a); end,
						hasAlpha = true
					},
					moreAlliedBackdropBackgroundColor = {
						type = 'color',
						name = L["More Allied than Hostiles Background Color"],
						desc = L["Sets the more Allied than Hostiles Background Color and Opacity"],
						order = 3,
						get = function() return VanasKoSWarnFrame:GetColor("WarnFrameMoreAlliedBGColor"); end,
						set = function(r, g, b, a) VanasKoSWarnFrame:SetColor("WarnFrameMoreAlliedBGColor", r, g, b, a); end,
						hasAlpha = true
					},
					resetBackgroundColors = {
						type = 'execute',
						name = L["Reset Background Colors"],
						desc = L["Resets all Background Colors to default Settings"],
						order = 4,
						func = function() 
									VanasKoSWarnFrame:SetColor("WarnFrameMoreHostileBGColor", 1.0, 0.0, 0.0, 0.5);
									VanasKoSWarnFrame:SetColor("WarnFrameMoreAlliedBGColor", 0.0, 1.0, 0.0, 0.5);
									VanasKoSWarnFrame:SetColor("WarnFrameDefaultBGColor", 0.5, 0.5, 1.0, 0.5);
								end,
					}
				}
			}
		}
	}
	dewdrop:Register(frame,
				'children', configOptions
				);
				
	VanasKoSGUI:AddConfigOption("WarnFrame", {
		type = 'group',
		name = L["KoS/Enemy/Friendly Warning Window"],
		desc = L["KoS/Enemy/Friendly Warning Window"],
		args = {
			enabled = {
				type = 'toggle',
				name = L["Enabled"],
				desc = L["Enabled"],
				order = 1,
				set = function() VanasKoS:TogOpt("enableWarnFrame"); VanasKoS:ToggleModuleActive("WarnFrame", VanasKoS:GetOpt("enableWarnFrame")); VanasKoSWarnFrame:Update(); end,
				get = function() return VanasKoS:GetOpt("enableWarnFrame"); end,
			},
			locked = {
				type = 'toggle',
				name = L["Locked"],
				desc = L["Locked"],
				order = 2,
				set = function() VanasKoS:TogOpt("WarnFrameLocked"); end,
				get = function() return VanasKoS:GetOpt("WarnFrameLocked"); end,
			},
			hideifinactive = {
				type = 'toggle',
				name = L["Hide if inactive"],
				desc = L["Hide if inactive"],
				set = function() VanasKoS:TogOpt("hideWarnFrameIfInactive"); VanasKoSWarnFrame:Update(); end,
				get = function() return VanasKoS:GetOpt("hideWarnFrameIfInactive"); end,
			},
		}
	});

	self:Update();
end

function VanasKoSWarnFrame:OnEnable()
	NOTIFYTIMERINTERVAL = VanasKoS:GetOpt("NotifyTimerInterval");
	self:RegisterEvent("VanasKoS_Player_Detected", "AddPlayer");
	self:Update();
end

function VanasKoSWarnFrame:OnDisable()
	self:UnregisterAllEvents();
	self:CancelAllScheduledEvents();
	nearbyKos = { };
	nearbyEnemys = { };
	nearbyFriendly = { };
	self.frame:Hide();
end

function VanasKoSWarnFrame:GetColor(which)
	return VanasKoS:GetOpt(which .. "R"), VanasKoS:GetOpt(which .. "G"), VanasKoS:GetOpt(which .. "B"), VanasKoS:GetOpt(which .. "A");
end

function VanasKoSWarnFrame:SetColor(which, r, g, b, a)
	VanasKoSWarnFrame.frame:SetBackdropColor(r, g, b, a)
	
	VanasKoS:SetOpt(which .. "R", r);
	VanasKoS:SetOpt(which .. "G", g);
	VanasKoS:SetOpt(which .. "B", b);
	VanasKoS:SetOpt(which .. "A", a);
end

function VanasKoSWarnFrame:RemovePlayer(name)
	for k,v in pairs(nearbyKos) do
		if(v[1] == name) then
			tremove(nearbyKos, k);
		end
	end
	for k,v in pairs(nearbyEnemys) do
		if(v[1] == name) then
			tremove(nearbyEnemys, k);
		end
	end
	for k,v in pairs(nearbyFriendly) do
		if(v[1] == name) then
			tremove(nearbyFriendly, k);
		end
	end
	
	self:Update();
end

function VanasKoSWarnFrame:AddPlayer(name, guild, faction)
	name = string.trim(name);
	
	if(name == L["_Unknown Entity_"]) then
		return nil;
	end

	self:RemovePlayer(name)
	if(faction == "kos") then
		tinsert(nearbyKos, { name, faction });
		self:CancelScheduledEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, self, name);
		self:ScheduleEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, NOTIFYTIMERINTERVAL, self, name);
		VanasKoSWarnFrame:Update();

		return nil;
	end
	if(faction == "enemy") then
		tinsert(nearbyEnemys, { name, faction });
	end
	if(faction == "friendly") then
		tinsert(nearbyFriendly, { name, faction });
	end

	self:CancelScheduledEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, self, name);
	self:ScheduleEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, 10, self, name);
	self:Update();
end

function VanasKoSWarnFrame:DebugShowTables()
	self:Print("showtables");
	-- kos
	for k, v in pairs(nearbyKos) do
		self:Print(v[1]);
	end

	-- enemy but not kos
	for k, v in pairs(nearbyEnemys) do
		self:Print(v[1]);
	end

	-- friendly players
	for k, v in pairs(nearbyFriendly) do
		self:Print(v[1]);
	end
end

function VanasKoSWarnFrame:Update()
	-- +1, because it doesn't count you
	-- more hostile
	if( (#nearbyKos+#nearbyEnemys) > (#nearbyFriendly+1)) then
		local r, g, b, a = self:GetColor("WarnFrameMoreHostileBGColor");
		VanasKoS_WarnFrame:SetBackdropColor(r, g, b, a);
	end
	-- more allied
	if( (#nearbyKos+#nearbyEnemys) < (#nearbyFriendly+1)) then
		local r, g, b, a = self:GetColor("WarnFrameMoreAlliedBGColor");
		VanasKoS_WarnFrame:SetBackdropColor(r, g, b, a);
	end
	-- default
	if( ((#nearbyKos+#nearbyEnemys) == 0) or ((#nearbyKos+#nearbyEnemys) == (#nearbyFriendly+1)) ) then
		local r, g, b, a = self:GetColor("WarnFrameDefaultBGColor");
		VanasKoS_WarnFrame:SetBackdropColor(r, g, b, a);
	end

	local counter = 0;

	-- kos
	if(VanasKoS:GetOpt("WarnFrameShowKoS")) then
		for k, v in pairs(nearbyKos) do
			if (counter < 5) then
				getglobal("VanasKoS_WarnFrameText" .. counter):SetTextColor(1.0, 0.0, 1.0);
				getglobal("VanasKoS_WarnFrameText" .. counter):SetText(v[1]);
				counter = counter + 1;
			end
		end
	end
	
	-- enemy but not kos
	if(VanasKoS:GetOpt("WarnFrameShowHostile")) then
		for k, v in pairs(nearbyEnemys) do
			if (counter < 5) then
				getglobal("VanasKoS_WarnFrameText" .. counter):SetTextColor(1.0, 0.0, 0.0);
				getglobal("VanasKoS_WarnFrameText" .. counter):SetText(v[1]);
				counter = counter + 1;
			end
		end
	end
	
	-- friendly players
	if(VanasKoS:GetOpt("WarnFrameShowFriendly")) then
		for k, v in pairs(nearbyFriendly) do
			if (counter < 5) then
				getglobal("VanasKoS_WarnFrameText" .. counter):SetTextColor(0.0, 1.0, 0.0);
				getglobal("VanasKoS_WarnFrameText" .. counter):SetText(v[1]);
				counter = counter + 1;
			end
		end
	end
	
	if(counter < 5) then
		for i=counter, 5, 1 do
			getglobal("VanasKoS_WarnFrameText" .. counter):SetText("");
		end
	end

	if(VanasKoS:GetOpt("enableWarnFrame")) then
		if(VanasKoS:GetOpt("hideWarnFrameIfInactive")) then
			if(counter > 0) then
				if(not self.frame:IsVisible()) then
--					self.frame:Show();
					UIFrameFadeIn(self.frame, 0.1, 0.0, 1.0);
					self.frame:Show();
				end
			else
				if(self.frame:IsVisible()) then
					UIFrameFadeOut(self.frame, 0.1, 1.0, 0.0);
					self.frame.fadeInfo.finishedFunc = function() VanasKoS_WarnFrame:Hide(); end;
				end
			end
		else
			if(not self.frame:IsVisible()) then
				self.frame:Show();
			end
		end
	else
		self.frame:Hide();
	end
end
